<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');
include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/functions.php');

// Get all post types that are public

$post_types = get_post_types(array('public' => true));
$wpsite_flyout_fire_db = new WPsite_Flyout_Fire_DB();

global $wp_roles;

// Check if the user saves a flyout_fire

if (( isset($_POST['submit']) || isset($_POST['submit_aweber']) ) && check_admin_referer(WPsite_Flyout_Fire::$prefix . 'admin_settings')) {

	if (empty($_POST[WPsite_Flyout_Fire::$prefix_dash . 'name'])) {
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo WPsite_Flyout_Fire::$dashboard_page; ?>";
		</script>
		<?php
	}

	$flyout_fire = WPsite_Flyout_Fire_Admin_Functions::save_data();

	if (isset($_POST["submit"]) && $_POST["submit"] == "Save") {
		$wpsite_flyout_fire_db->add_data($flyout_fire);
		?>
		<script type="text/javascript">
			window.location= "<?php echo get_admin_url(); ?>admin.php?page=<?php echo WPsite_Flyout_Fire::$dashboard_page; ?>";
		</script>
		<?php
	}

	if (isset($_POST["submit"]) && $_POST["submit"] == "Update") {
		$flyout_fire['id'] = $_GET['flyout_fire_id'];
		$wpsite_flyout_fire_db->update_data($flyout_fire);
/*
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo WPsite_Flyout_Fire::$dashboard_page; ?>";
		</script>
		<?php
*/
	}
}

// Check if updating a record or adding a new one

$default_flyout_fire = WPsite_Flyout_Fire_Admin_Functions::default_flyout_fire();

if (isset($_GET["flyout_fire_id"])) {
	$edit_data = $wpsite_flyout_fire_db->get_data_from_id($_GET["flyout_fire_id"]);
} else {

	// Create default values from all post types

	$trigger = array();
	foreach ($post_types as $post_type) {
		$trigger[$post_type] = array(
			'all'	=>	1,
			'id'	=>	''
		);
	}

	$trigger['type'] = 'site';
	$trigger['category'] = array(
		'all' => 1,
		'id' => ''
	);
	$trigger['tag'] = array(
		'id' => ''
	);

	$trigger['args'] = $default_flyout_fire['trigger']['args'];

	$edit_data = array_merge($default_flyout_fire, array('trigger' => $trigger));
}

// Unserialize all data values that are serialzed in database

if(!is_array($edit_data['trigger'])) $edit_data['trigger'] = (array) WPsite_Flyout_Fire_Admin_Functions::mb_unserialize($edit_data['trigger']);
if(!is_array($edit_data['text_link'])) $edit_data['text_link'] = (array) WPsite_Flyout_Fire_Admin_Functions::mb_unserialize($edit_data['text_link']);
if(!is_array($edit_data['social'])) $edit_data['social'] = (array) WPsite_Flyout_Fire_Admin_Functions::mb_unserialize($edit_data['social']);
if(!is_array($edit_data['news_letter'])) $edit_data['news_letter'] = (array) WPsite_Flyout_Fire_Admin_Functions::mb_unserialize($edit_data['news_letter']);
if(!is_array($edit_data['args'])) $edit_data['args'] = (array) WPsite_Flyout_Fire_Admin_Functions::mb_unserialize($edit_data['args']);

$edit_data['args']['font_family'] = stripcslashes($edit_data['args']['font_family']);


$post_types_array = array();
foreach ($post_types as $post_type) {
	$post_types_array[] = $post_type;
}

wp_localize_script(WPsite_Flyout_Fire::$prefix . 'add_edit_js', 'wps_ff_data', array(
	'ajaxurl'		=> admin_url( 'admin-ajax.php' ),
	'prefix'		=> WPsite_Flyout_Fire::$prefix,
	'prefix_dash' 	=> WPsite_Flyout_Fire::$prefix_dash,
	'post_types'	=> $post_types_array,
));

include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/views/add-edit.php');