<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

// Create Table if one does not exist

WPsite_Stats_FF::createTable();

// Get global settings

$global_settings = get_option(self::$prefix . 'global_settings');

if ( $global_settings === false ) {
	$global_settings = WPsite_Flyout_Fire_Admin_Functions::default_global_settings();
}

// Export data

if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'export_data')) {

	$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
	$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

	if (isset($_GET[self::$prefix_dash . 'start-date']) && $_GET[self::$prefix_dash . 'start-date'] != '') {
		$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'start-date']));
	}

	if (isset($_GET[self::$prefix_dash . 'end-date']) && $_GET[self::$prefix_dash . 'end-date'] != '') {
		$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'end-date']));
	}

	global $wpdb;

	include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

	$flyout_fire_stats = WPsite_Stats_FF::getStats($start_date, $end_date, $_GET['flyout_fire_id']);
	$flyout_fires = $wpdb->get_results("SELECT * FROM `" . WPsite_Flyout_Fire_DB::getTableName() . "`");

	foreach ($flyout_fires as $flyout_fire) {
		foreach ($flyout_fire_stats as $key => $flyout_fire_stat) {
			if ($flyout_fire->id == $flyout_fire_stat['flyout_fire_id']) {
				$flyout_fire_stats[$key] = array('flyout_fire_name' => $flyout_fire->name) + $flyout_fire_stats[$key];
				$flyout_fire_stats[$key]['click-through-rate'] = round(($flyout_fire_stats[$key]['clicks']/$flyout_fire_stats[$key]['impressions']) * 100,2) . '%';
			}
		}
	}

	// Unset indexes

	foreach ($flyout_fire_stats as $key => $flyout_fire_stat) {
		unset($flyout_fire_stats[$key]['id']);
		unset($flyout_fire_stats[$key]['flyout_fire_id']);
	}

	$filename =  self::$prefix . 'stats.csv';
	$export_file = fopen(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'exports/' . $filename, "w");
	fputcsv($export_file, array('Name', 'Date', 'Impressions', 'Clicks', 'Click-Through-Rate'));

	foreach (array_reverse($flyout_fire_stats) as $flyout_fire_stat) {
	    fputcsv($export_file, $flyout_fire_stat);
	}

	fclose($export_file);

	?>
	<script type="text/javascript">
		window.location = '<?php echo WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
	</script>
	<?php
}

// Reset Stats

if (isset($_GET['action']) && $_GET['action'] == 'reset_stats' && isset($_GET['flyout_fire_id']) && isset($_GET['flyout_fire_name'])) {

	include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "core/model/stats.php");

	WPsite_Stats_FF::deleteStats($_GET['flyout_fire_id']);

	?>
	<script type="text/javascript">
		window.location= "<?php echo get_admin_url() . "admin.php?page=" . self::$stats_page . '&flyout_fire_id=' . $_GET['flyout_fire_id'] . '&flyout_fire_name=' . $_GET['flyout_fire_name'];?>";
	</script>
	<?php

}

include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/views/stats.php');