/**
 *
 * Created by Kyle Benk kjbenk@gmail.com
 *
 * 12/14
 */

jQuery(document).ready(function($) {

	var impression_color           	= "rgb(74, 174, 238)";
	var impression_color_light 		= "rgba(74, 174, 238, 0.2)";
	var conversion_color       		= "rgb(241, 89, 40)";
	var conversion_color_light 		= "rgba(241, 89, 40, 0.2)";

	// Load stats via AJAX

	$.post(ajaxurl, {
			'action': 'wps_ff_stats_load',
			'start_date' : getQuerystring(wps_ff_stats_data.prefix_dash + 'start-date'),
			'end_date' : getQuerystring(wps_ff_stats_data.prefix_dash + 'end-date'),
			'flyout_fire_name' : getQuerystring('flyout_fire_name'),
			'flyout_fire_id' : getQuerystring('flyout_fire_id', false)}, function(response) {

		response = jQuery.parseJSON(response);

		$("#" + wps_ff_stats_data.prefix_dash + "loading-stats").remove();
		$(response.stats_content).insertAfter("#" + wps_ff_stats_data.prefix_dash + "before-table");

		if ($("#" + wps_ff_stats_data.prefix_dash + "line-graph").length != 0) {

			var dates = [];
			var flyout_fires = [];
			var impressions = [];
			var clicks = [];
			var max_name_length = 13;

			$.each(response.flyout_fire_stats, function(key, value){
				$.each(value, function(key_1, value_1){

					if (key_1 == 'flyout_fire_name') {

						//if (value_1.length >= max_name_length) {
							//flyout_fires.push(value_1.substring(0, max_name_length) + '...');
						//} else {
							flyout_fires.push(value_1);
						//}
					}

					if (key_1 == 'date') {
						dates.push(value_1);
					}

					if (key_1 == 'impressions') {
						impressions.push(value_1);
					}

					if (key_1 == 'clicks') {
						clicks.push(value_1);
					}
				});
			});


			if (getQuerystring('flyout_fire_name') != '') {
				var labels = dates;
			} else {
				var labels = flyout_fires;
			}


			// Line Graph

			var lineChartData = {
				labels : labels,
				datasets : [
					{
						label: "Impressions",
						fillColor : impression_color_light,
						strokeColor : impression_color,
						pointColor : impression_color,
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : impression_color,
						data : impressions
					},
					{
						label: "Clicks",
						fillColor : conversion_color_light,
						strokeColor : conversion_color,
						pointColor : conversion_color,
						pointStrokeColor : "#fff",
						pointHighlightFill : "#fff",
						pointHighlightStroke : conversion_color,
						data : clicks
					}
				]

			}

			// Show No stats

			if (impressions.length == 0) {

				var lineChartData = {
					labels : ['1-1-1970','1-2-1970','1-3-1970','1-4-1970','1-5-1970','1-6-1970','1-7-1970','1-8-1970','1-9-1970'],
					datasets : [
						{
							label: "Impressions",
							fillColor : impression_color_light,
							strokeColor : impression_color,
							pointColor : impression_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : impression_color,
							data : ['25','45','43','18','26','34','21','20','29']
						},
						{
							label: "Clicks",
							fillColor : conversion_color_light,
							strokeColor : conversion_color,
							pointColor : conversion_color,
							pointStrokeColor : "#fff",
							pointHighlightFill : "#fff",
							pointHighlightStroke : conversion_color,
							data : ['12','3','8','6','11','6','3','5','7']
						}
					]

				}

				var ctx = document.getElementById(wps_ff_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Line(lineChartData, {
					responsive: true,
				});
				$('#wps-ff-line-graph').css('opacity', '0.5');
				$('<h3 style="width: 70%;text-align: center;position: absolute;margin-top: 60px;">Example Data</h3><h3 style="width: 70%;text-align: center;position: absolute;margin-top: 100px;">No Stats Yet</h3>').insertBefore('#wps-ff-line-graph');
			}

			// Show Line graph if there are multiple stats

			else if (impressions.length > 1 && getQuerystring('flyout_fire_name') != '') {
				var ctx = document.getElementById(wps_ff_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Line(lineChartData, {
					responsive: true,
				});
			}

			// Show Bar graph if there is only one day of stats  or on all Firebar stats page

			else {
				var ctx = document.getElementById(wps_ff_stats_data.prefix_dash + "line-graph").getContext("2d");
				window.myLine = new Chart(ctx).Bar(lineChartData, {
					responsive: true,
				});
			}
		}

		$($.bootstrapSortable);
	});

	// Save weekly email settings

	$('input[name="' + wps_ff_stats_data.prefix_dash + 'send-weekly-email"]').change(function(){

		$.post(ajaxurl, {
			'action': 'wps_ff_send_weekly_email',
			'send_weekly_email': $('input[name="' + wps_ff_stats_data.prefix_dash + 'send-weekly-email"]').prop('checked')}, function(response) {

			response = jQuery.parseJSON(response);

		});
	});


	// Date Pickers

	$('#' + wps_ff_stats_data.prefix_dash + 'start-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_ff_stats_data.prefix_dash + 'end-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_ff_stats_data.prefix_dash + 'end-datepicker')
		.data("DateTimePicker")
		.maxDate( moment(wps_ff_stats_data.today, "M/D/Y") );

	$('#' + wps_ff_stats_data.prefix_dash + 'start-datepicker')
		.data("DateTimePicker")
		.maxDate( moment(wps_ff_stats_data.today, "M/D/Y") );

	$('#' + wps_ff_stats_data.prefix_dash + 'end-datepicker')
		.data("DateTimePicker")
		.minDate( $('#' + wps_ff_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

	$('#' + wps_ff_stats_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
       $('#' + wps_ff_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
    });

    $('#' + wps_ff_stats_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
       $('#' + wps_ff_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
    });

    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}

	// Reset stats

	$("." + wps_ff_stats_data.prefix_dash + "reset-stats").click(function(e){

		e.preventDefault();

		var url = $(this).attr('data-url');

		$(".modal-body").find('p').html('Are you sure you want to reset the stats for flyout ' + $(this).attr('data-name') + '?');

		$("#modal-success").click(function(){
			$('#resetStats').modal('hide');
			window.location = url;
		});
	});
});