<?php

// Define all class names to be used for styling the Flyout Fire

$shadow = isset($args['shadow']) && $args['shadow'] == 'yes' ? WPsite_Flyout_Fire::$prefix_dash . 'container-' . strtolower($location) . '-shadow' : '';

$full = '';

if (isset($args['full']) && $args['full'] == 'yes') {
	$full = WPsite_Flyout_Fire::$prefix_dash . 'full-width';

	if ($location == 4 || $location == 6) {
		$full = WPsite_Flyout_Fire::$prefix_dash . 'full-height';
	}
}

$container = WPsite_Flyout_Fire::$prefix_dash . 'container ' .
	WPsite_Flyout_Fire::$prefix_dash . 'container-' . $args['size'] . ' ' .
	WPsite_Flyout_Fire::$prefix_dash . 'container-' . $args['shape'] . ' ' .
	WPsite_Flyout_Fire::$prefix_dash . 'container-' . $args['text_align'] . ' ' .
	$full . ' ' .
	WPsite_Flyout_Fire::$prefix_dash . 'container-' . strtolower($location) . ' ' . $shadow;

$val['args'] = unserialize($val['args']);

$flyout_fire_icon = 'fa ' . $val['args']['icon'];

$stub = '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stub ' . WPsite_Flyout_Fire::$prefix_dash . 'stub-' . strtolower($location) . ' ' . $full . '" style="display: none;">
		<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'show ' . WPsite_Flyout_Fire::$prefix_dash . 'show-' . strtolower($location) . ' ' . WPsite_Flyout_Fire::$prefix_dash . 'show-' . strtolower($location) . '-' . $args['stub_shape'] . ' ' . $flyout_fire_icon . '"></span>
	</div>';

$close = '<div><span class="' . WPsite_Flyout_Fire::$prefix_dash . 'close ' .
	WPsite_Flyout_Fire::$prefix_dash . 'close-' . $location . ' ' . $flyout_fire_icon . '"></span></div>';

$close_img = strtolower($location) == 'top' ? WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/img/top-arrow.png' : WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/img/bottom-arrow.png';
$show_img = strtolower($location) == 'top' ? WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/img/bottom-arrow.png' : WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/img/top-arrow.png';

$text_link = unserialize($val['text_link']);

?>

<div class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>wrap <?php echo WPsite_Flyout_Fire::$prefix_dash; ?>wrap-<?php echo $location; ?>">

	<!-- This is used to record stats so please leave it alone -->
	<p id="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>flyout-fire-id" data-flyout-fire-id="<?php echo $val['id']; ?>"></p>
	<!-- This is used to record stats so please leave it alone -->

	<div id="<?php echo WPsite_Flyout_Fire::$prefix_dash . 'container-' . $val['id']; ?>" class="<?php echo $container; ?> <?php echo WPsite_Flyout_Fire::$prefix_dash; ?>container-<?php echo $template; ?>" <?php echo $background; ?>>
		<div>

		<?php if (isset($args['close_button']) && $args['close_button'] ) { ?>

		<span class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>close-button <?php echo WPsite_Flyout_Fire::$prefix_dash; ?>close-button-<?php echo $location; ?>">
			<i class="fa fa-times"></i>
		</span>

		<?php } ?>

		<?php do_action('wps_ff_before_heading'); ?>
		<?php do_action('wps_ff_before_heading_' . $val['id']); ?>

		<?php if (isset($args['heading']) && $args['heading'] != '') { ?>

		<h2 class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>heading"><?php echo $args['heading']; ?></h2>

		<?php } ?>

		<?php do_action('wps_ff_after_heading'); ?>
		<?php do_action('wps_ff_after_heading_' . $val['id']); ?>

		<?php if (isset($text) && $text != '') { ?>

		<p class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>text"><?php echo do_shortcode(html_entity_decode($text)); ?></p>

		<?php } ?>

		<?php include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/views/' . $template . '.php'); ?>

		<?php do_action('wps_ff_before_footer'); ?>
		<?php do_action('wps_ff_before_footer_' . $val['id']); ?>

		<?php if (isset($args['footer']) && $args['footer'] != '') { ?>

			<!-- Footer -->

			<div class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>footer col-xs-12" style="padding: 0px;">
				<p><i class="fa <?php echo $args['footer_icon']; ?>"></i> <?php echo html_entity_decode($args['footer']); ?></p>
			</div>

		<?php } ?>

		<?php do_action('wps_ff_after_footer'); ?>
		<?php do_action('wps_ff_after_footer_' . $val['id']); ?>

		<?php if (isset($args['powered_by']) && $args['powered_by'] == 'yes') { ?>

			<!-- Powered By -->

			<div class="<?php echo WPsite_Flyout_Fire::$prefix_dash; ?>powered-by col-xs-12" style="padding: 0px;">
				<p><?php _e('Powered by ', WPsite_Flyout_Fire::$text_domain); ?> <a href="https://99robots.com/products/flyout-fire-slide-in-panels-for-wordpress/?utm_source=flyout-fire&utm_medium=plugin&utm_content=credit&utm_campaign=flyout-fire-credit-link"><?php _e('Flyout Fire', WPsite_Flyout_Fire::$text_domain); ?></a></p>
			</div>

		<?php } ?>

		</div>
	</div>

	<?php  if ( !isset($args['close_button']) || ( isset($args['close_button']) && !$args['close_button'] ) ) {
		echo $stub;
	} ?>

</div>