<?php

$thumbnail_class = isset($args['post']['thumbnail']) &&  $args['post']['thumbnail'] == 'yes' ? WPsite_Flyout_Fire::$prefix_dash . 'has-thumbnail' : '';

$out = '<ul class="' . WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-list ' . $thumbnail_class . '">';

$posts = get_transient(WPsite_Flyout_Fire::$prefix . 'recent_posts');

if (false === $posts){
	$posts = get_posts(array(
		 'posts_per_page' 	=> $recent_posts['count'],
		 'genre' 			=> $recent_posts['tag'],
		 'post_status' 		=> 'publish'
	));

	set_transient(WPsite_Flyout_Fire::$prefix . 'recent_posts', $posts, 300);
}

if (isset($posts) && is_array($posts)) {

	foreach($posts as $post) {

		// Thumbnail

		$thumbnail_link = '';
		$thumbnail_class = WPsite_Flyout_Fire::$prefix_dash . 'no-thumbnail';

		if (isset($args['post']['thumbnail']) &&  $args['post']['thumbnail'] == 'yes') {
			$thumbnail = wp_get_attachment_url( get_post_thumbnail_id($post->ID) );

			if (isset($thumbnail) && $thumbnail != '') {
				$thumbnail_link = '<a href="' . get_permalink( $post->ID ) . '"><img class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-image" src="' . $thumbnail . '"/></a>';
				$thumbnail_class = WPsite_Flyout_Fire::$prefix_dash . 'has-thumbnail';
			}
		}

		$out .= '<li class="' . $thumbnail_class . '">';

		$out .= '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-left ' . $thumbnail_class . '">' . $thumbnail_link . '</div>';

		$out .= '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-right ' . $thumbnail_class . '">';

			$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-title">
					<a href="' . get_permalink( $post->ID ) . '">' . $post->post_title . '</a>
				</p>';

			// Meta Data

			if (isset($args['post']['meta_data']) &&  $args['post']['meta_data'] == 'yes') {

				$out .= '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-meta-data">';

					$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-date">' . date('M d, Y', strtotime($post->post_date)) .'</p>';

					$out .= ' &bull; ';

					$comment_count = wp_count_comments( $post->ID );

					if ($comment_count->approved == 0) {
						$comments = __('0', WPsite_Flyout_Fire::$text_domain) . ' <i class="fa fa-comments"></i>';
					} else if ($comment_count->approved == 1) {
						$comments = __('1', WPsite_Flyout_Fire::$text_domain) . ' <i class="fa fa-comment"></i>';
					} else {
						$comments = sprintf(__('%s', WPsite_Flyout_Fire::$text_domain), $comment_count->approved) . ' <i class="fa fa-comments"></i>';
					}

					$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-comments"><a href="' . get_comments_link( $post->ID ) . '">' . $comments . '</a></p>';

					$out .= ' &bull; ';

					$author = get_userdata( $post->post_author );

					$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-author">';
						$out .= '<a href="' . get_site_url() . '?author=' . $post->post_author . '" target="_self">';
							$out .= $author->display_name;
						$out .= '</a>';
					$out .= '</p>';

					// Category


/*
					$category = get_the_category($post->ID);

					if (isset($category[0])) {


						$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-category">';
							$out .= __('Posted in: ', WPsite_Flyout_Fire::$text_domain);
							$out .= '<a href="' . get_site_url() . '?cat=' . $category[0]->cat_ID . '" target="_self">';
								$out .= $category[0]->cat_name;
							$out .= '</a>';
						$out .= '</p>';

					}
*/

				$out .= '</div>';

			}

		$out .= '</div>';

		// Excerpt

		if (isset($args['post']['excerpt']) &&  $args['post']['excerpt'] == 'yes') {

			if (isset($post->post_excerpt) && $post->post_excerpt != '') {
				$out .= '<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'post-excerpt">' . $post->post_excerpt . '</p>';
			}

		}

		$out .= '</li>';
	}
}

$out .= '</ul>';

echo $out;