<?php

include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . "core/includes/twitter/codebird.php");

\Codebird\Codebird::setConsumerKey($twitter['api_key'], $twitter['api_secret']);

$cb = \Codebird\Codebird::getInstance();
$cb->setToken($twitter['token'], $twitter['token_secret']);
$cb->setReturnFormat(CODEBIRD_RETURNFORMAT_ARRAY);

$count = 0;
$target = 'target="_blank"';

$out = '<ul class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-feed">';

$twitter_data = get_transient(WPsite_Flyout_Fire::$prefix . 'twitter_feed');

if (false === $twitter_data){
	try {
		$twitter_data = (array) $cb->statuses_userTimeline();
	} catch (Exception $e) {
		error_log($e);
		_e('An Error as occurred and we were unable to get your tweets.');
	}

	set_transient(WPsite_Flyout_Fire::$prefix . 'twitter_feed', $twitter_data, 300);
}

if (isset($twitter_data) && is_array($twitter_data)) {

	foreach($twitter_data as $message) {

		if ($count >= $twitter['count']) {
			break;
		}

		if (!isset($message['text'])) {
			continue;
		}

		$msg = $message['text'];

		$out .= '<li class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-feed-item" style="list-style: none;margin-bottom: 10px;">';

		$hashtag_link_pattern = '<a href="http://twitter.com/search?q=%%23%s&src=hash" rel="nofollow" target="_blank">#%s</a>';
		$url_link_pattern = '<a href="%s" rel="nofollow" target="_blank" title="%s">%s</a>';
		$user_mention_link_pattern = '<a href="http://twitter.com/%s" rel="nofollow" target="_blank" title="%s">@%s</a>';
		$media_link_pattern = '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-image-link"><a href="%s" rel="nofollow" target="_blank" title="%s">%s</a></div>';

		$text = $message['text'];
		$entity_holder = array();
		$media_image = '';

		if (isset($message['entities']['media'])) : foreach ($message['entities']['media'] as $media) {
			$entity = new stdclass();
			$entity->start = $media['indices'][0];
			$entity->end = $media['indices'][1];
			$entity->length = $media['indices'][1] - $media['indices'][0];
			$entity->replace = '';//sprintf($media_link_pattern, $media['url'], $media['expanded_url'], '');

			$media_image = sprintf($media_link_pattern, $media['url'], $media['expanded_url'], '<img class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-image" src="' . $media['media_url_https'] . '"/>');

			$entity_holder[$entity->start] = $entity;
		} endif;

		if (isset($message['entities']['hashtags'])) : foreach ($message['entities']['hashtags'] as $hashtag) {

			$entity = new stdclass();
			$entity->start = $hashtag['indices'][0];
			$entity->end = $hashtag['indices'][1];
			$entity->length = $hashtag['indices'][1] - $hashtag['indices'][0];
			$entity->replace = sprintf($hashtag_link_pattern, strtolower($hashtag['text']), $hashtag['text']);

			$entity_holder[$entity->start] = $entity;
		} endif;

		if (isset($message['entities']['urls'])) : foreach ($message['entities']['urls'] as $url) {
			$entity = new stdclass();
			$entity->start = $url['indices'][0];
			$entity->end = $url['indices'][1];
			$entity->length = $url['indices'][1] - $url['indices'][0];
			$entity->replace = sprintf($url_link_pattern, $url['url'], $url['expanded_url'], $url['display_url']);

			$entity_holder[$entity->start] = $entity;
		} endif;

		if (isset($message['entities']['user_mentions'])) : foreach ($message['entities']['user_mentions'] as $user_mention) {

			$entity = new stdclass();
			$entity->start = $user_mention['indices'][0];
			$entity->end = $user_mention['indices'][1];
			$entity->length = $user_mention['indices'][1] - $user_mention['indices'][0];
			$entity->replace = sprintf($user_mention_link_pattern, strtolower($user_mention['screen_name']), $user_mention['name'], $user_mention['screen_name']);

			$entity_holder[$entity->start] = $entity;

		} endif;

		krsort($entity_holder);

		foreach($entity_holder as $entity) {
			$text = substr_replace($text, $entity->replace, $entity->start, $entity->length);
		}

		if (!isset($media_image) || $media_image == '') {
			$media_image = '<img class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-image" src="' . $message['user']['profile_image_url'] . '"/>';
		}

		$text = $media_image . $text;

		$follow_button = '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'twitter-follow-button"><a class="twitter-follow-button" href="https://twitter.com/' . $message['user']['screen_name'] . '" data-show-count="true" data-lang="en"> Follow @' . $message['user']['screen_name'] . ' </a><script type="text/javascript">window.twttr=(function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],t=window.twttr||{};if(d.getElementById(id))return;js=d.createElement(s);js.id=id;js.src="https://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);t._e=[];t.ready=function(f){t._e.push(f);};return t;}(document,"script","twitter-wjs"));</script></div>';

		$out .= $text;
		$out .= '</li>';
		$count++;
	}
}

$out .= '</ul>';

$out = $follow_button . $out;

echo $out;